<?php
/**
 * 2007-2018 ETS-Soft
 *
 * NOTICE OF LICENSE
 *
 * This file is not open source! Each license that you purchased is only available for 1 wesite only.
 * If you want to use this file on more websites (or projects), you need to purchase additional licenses. 
 * You are not allowed to redistribute, resell, lease, license, sub-license or offer our resources to any third party.
 * 
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please contact us for extra customization service at an affordable price
 *
 *  @author ETS-Soft <etssoft.jsc@gmail.com>
 *  @copyright  2007-2018 ETS-Soft
 *  @license    Valid for 1 website (or project) for each purchase of license
 *  International Registered Trademark & Property of ETS-Soft
 */

if (!defined('_PS_VERSION_'))
	exit;
include_once(_PS_MODULE_DIR_.'ets_pres2presconnector/classes/DataExport.php'); 
include_once(_PS_MODULE_DIR_.'ets_pres2presconnector/classes/ExtraExport.php');   
class Ets_pres2presconnector extends Module
{
    private $errorMessage;
    public $configs;
    public $baseAdminPath;
    private $_html;
    public $url_module;
    public $errors = array();
    public $tables;
    public $data_exports='';
    public $divide_file=1;
    public $number_record=500;
    public $pres_version;
    public $context;
    public function __construct()
	{
		$this->name = 'ets_pres2presconnector';
		$this->tab = 'front_office_features';
		$this->version = '1.0.1';
		$this->author = 'ETS-Soft';
		$this->need_instance = 0;
		$this->secure_key = Tools::encrypt($this->name);        
		$this->bootstrap = true;
        $this->module_key = '8c4686a2fe6d643fe0dea93e2e0a7082';
        if(version_compare(_PS_VERSION_, '1.7', '>='))
            $this->pres_version=1.7;
        elseif(version_compare(_PS_VERSION_, '1.7', '<') && version_compare(_PS_VERSION_, '1.6', '>=') )
            $this->pres_version=1.6;
        elseif(version_compare(_PS_VERSION_, '1.6', '<') && version_compare(_PS_VERSION_, '1.5', '>=') )
            $this->pres_version=1.5;
        elseif(version_compare(_PS_VERSION_, '1.5', '<') && version_compare(_PS_VERSION_, '1.4', '>=') )
            $this->pres_version=1.4;
        else
            $this->pres_version=1.3;
        if($this->pres_version<=1.4)
            $this->data_exports='employees,categories,customers,manufactures,suppliers,carriers,vouchers,products,orders,cms_cateogories,cms,messages';
        else
        {
            if(Tools::isSubmit('allshop'))
                $this->data_exports='shops,employees,categories,customers,manufactures,suppliers,carriers,cart_rules,catelog_rules,products,orders,cms_cateogories,cms,messages';
            else
                $this->data_exports='employees,categories,customers,manufactures,suppliers,carriers,cart_rules,catelog_rules,products,orders,cms_cateogories,cms,messages';
        }
            
		parent::__construct();
        $this->url_module = $this->_path;
        $this->displayName = $this->l('Prestashop connector');
		$this->description = $this->l('Connect Prestashop websites for migration purpose!');
    }
    /**
	 * @see Module::install()
	 */
    public function install()
	{
	   Configuration::updateValue('ETS_PRES2PRES_TOCKEN',$this->genSecure(6));
       Configuration::updateValue('ETS_PRES2PRES_CONNECTOR',1);
	   if($this->pres_version==1.4)
       {
            return parent::install()&&$this->registerHook('header');
       }
	   else
       {
            return parent::install()        
            && $this->registerHook('displayBackOfficeHeader')&& $this->registerHook('header')
            && $this->registerHook('displayBackOfficeFooter');
       }        
    }
    /**
	 * @see Module::uninstall()
	 */
	public function uninstall()
	{
        Configuration::deleteByName('ETS_PRES2PRES_TOCKEN');
        Configuration::deleteByName('ETS_PRES2PRES_CONNECTOR');
        return parent::uninstall();
    }    
    public function hookHeader()
    {
        if(Tools::isSubmit('presconnector') && Tools::getValue('pres2prestocken')==Configuration::get('ETS_PRES2PRES_TOCKEN') && Configuration::get('ETS_PRES2PRES_CONNECTOR'))
            $this->processExport();
    }  
    public function getContent()
	{
        if(!$this->active)
            return '';
        $errors=array();
        $html ='';
        $context=Context::getContext();
        if(Tools::isSubmit('btnSubmit'))
        {
            if(!Tools::getValue('ETS_PRES2PRES_TOCKEN'))
            {
                $errors[]=$this->l('Secure access token is required');
                $html .=$this->displayError($errors);
            }
            else
            {
                Configuration::updateValue('ETS_PRES2PRES_CONNECTOR',Tools::getValue('ETS_PRES2PRES_CONNECTOR'));
                Configuration::updateValue('ETS_PRES2PRES_TOCKEN',Tools::getValue('ETS_PRES2PRES_TOCKEN'));
                $html .= $this->displayConfirmation($this->l('Settings updated'));
            }
        }
        if(Tools::isSubmit('btnSubmitDownload'))
            $this->processExport();
        if($this->pres_version==1.4)
        {
            $connector_url=(Configuration::get('PS_SSL_ENABLED_EVERYWHERE')?'https://'.Configuration::get('PS_SHOP_DOMAIN_SSL'):'http://'.Configuration::get('PS_SHOP_DOMAIN')).__PS_BASE_URI__.'modules/'.$this->name.'/connector.php';
        }
        else
        {
            $connector_url =(Configuration::get('PS_SSL_ENABLED_EVERYWHERE')?'https://':'http://').$context->shop->domain.$context->shop->getBaseURI().'modules/'.$this->name.'/connector.php'.(Configuration::get('PS_MULTISHOP_FEATURE_ACTIVE') && Shop::getContext() == Shop::CONTEXT_ALL?'?allshop=1':'');
        }
        $context->smarty->assign(
            array(
                'ETS_PRES2PRES_CONNECTOR'=> Tools::getValue('ETS_PRES2PRES_CONNECTOR',Configuration::get('ETS_PRES2PRES_CONNECTOR')),
                'ETS_PRES2PRES_TOCKEN' => Tools::getValue('ETS_PRES2PRES_TOCKEN',Configuration::get('ETS_PRES2PRES_TOCKEN')),
                'connector_url' => $connector_url,
                'dir_path'=> $this->_path,
                'pres_version'=>$this->pres_version,
            )
        );    
        return $html.$this->display(__FILE__,'views/templates/hook/admin.tpl');
    }
    public function hookDisplayBackOfficeHeader()
    {
        $this->context->controller->addCSS($this->_path.'views/css/admin-icon.css','all');
        if(Tools::isSubmit('controller') && Tools::getValue('controller')=='AdminModules' && Tools::getValue('configure')==$this->name )
        {
            $this->context->controller->addCSS($this->_path.'views/css/pres2presconnector.admin.css','all');
            if($this->pres_version==1.5)
            {
                $this->context->controller->addCSS($this->_path.'views/css/font-awesome.css','all');
                $this->context->controller->addCSS($this->_path.'views/css/fic14.css','all');
            }
            $this->context->controller->addJquery();    
            $this->context->controller->addJS($this->_path.'views/js/pres2presconnector.admin.js');
            $this->context->controller->addJS($this->_path.'views/js/easytimer.min.js');
            $this->context->controller->addJS($this->_path.'views/js/tree.js');
        }
    }
  
    public function displayError($error)
    {
        $this->context->smarty->assign(
            array(
                'ybc_errors'=>$error,
            )
        );
        return $this->display(__FILE__,'views/templates/hook/errors.tpl');
    }
    public function exportContent($save=true)
    {
        $data_exports=explode(',',$this->data_exports);
        $contents =array();
        $totaldatas=array();
        if(in_array('shops',$data_exports))
        {
            $countShop = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'shop');
            $contents[]=array(
                'title'=>$this->l('Shops:'), 
                'count'=>$countShop, 
            );
            $totaldatas['shops'] =(int)$countShop;
        }
        if(in_array('employees',$data_exports))
        {
            $countEmployee = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'employee');
            $contents[]=array(
                'title'=>$this->l('Employees:'), 
                'count'=>$countEmployee, 
            );
            $totaldatas['employees'] =(int)$countEmployee;
            
        }
        if(in_array('categories',$data_exports))
        {
            $countCategory = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'category');
            $contents[]=array(
                'title'=>$this->l('Categories:'), 
                'count'=>$countCategory, 
            );
            $totaldatas['categories'] =(int)$countCategory;
        }
        if(in_array('products',$data_exports))
        {
            $countProduct= Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'product');
            $contents[]=array(
                'title'=>$this->l('Products:'), 
                'count'=>$countProduct, 
            );
            $totaldatas['products'] =(int)$countProduct;
        }
        if(in_array('customers',$data_exports))
        {
            $countCustomer = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'customer WHERE deleted=0');
            $contents[]=array(
                'title'=>$this->l('Customers:'), 
                'count'=>$countCustomer, 
            );
            $totaldatas['customers'] =(int)$countCustomer;
        }
        if(in_array('orders',$data_exports))
        {
            $countOrder = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'orders');
            $contents[]=array(
                'title'=>$this->l('Orders:'), 
                'count'=>$countOrder, 
            );
            $totaldatas['orders'] =(int)$countOrder;
        }
        if(in_array('manufactures',$data_exports))
        {
            $countManufacturer = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'manufacturer');
            $contents[]=array(
                'title'=>$this->l('Manufacturers:'), 
                'count'=>$countManufacturer, 
            );
            $totaldatas['manufactures'] =(int)$countManufacturer;
        }
        if(in_array('suppliers',$data_exports))
        {
            $countSupplier = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'supplier');
            $contents[]=array(
                'title'=>$this->l('Suppliers:'), 
                'count'=>$countSupplier, 
            );
            $totaldatas['suppliers'] =(int)$countSupplier;
        }
        if(in_array('carriers',$data_exports))
        {
            $countCarrier = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'carrier WHERE deleted=0');
            $contents[]=array(
                'title'=>$this->l('Carriers:'), 
                'count'=>$countCarrier, 
            );
            $totaldatas['carriers'] =(int)$countCarrier;
        }
        if(in_array('cart_rules',$data_exports))
        {
            $countCartRule = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'cart_rule');
            $contents[]=array(
                'title'=>$this->l('Cart rules:'), 
                'count'=>$countCartRule, 
            );
            $totaldatas['cart_rules'] =(int)$countCartRule;
        }
        if(in_array('catelog_rules',$data_exports))
        {
            $countSpecificPriceRule = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'specific_price_rule');
            $contents[]=array(
                'title'=>$this->l('Catelog rules:'), 
                'count'=>$countSpecificPriceRule, 
            );
            $totaldatas['catelog_rules'] =(int)$countSpecificPriceRule;
        }
        if(in_array('vouchers',$data_exports))
        {
            $countVoucher = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'discount');
            $contents[]=array(
                'title'=>$this->l('Vouchers:'), 
                'count'=>$countVoucher, 
            );
            $totaldatas['vouchers'] =(int)$countVoucher;
        }
        if(in_array('cms_cateogories',$data_exports))
        {
            $countcmscategory = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'cms_category');
            $contents[]=array(
                'title'=>$this->l('CMS categories:'), 
                'count'=>$countcmscategory, 
            );
            $totaldatas['cms_cateogories'] =(int)$countcmscategory;
        }
        if(in_array('cms',$data_exports))
        {
            $countcms = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'cms');
            $contents[]=array(
                'title'=>$this->l('CMSs:'), 
                'count'=>$countcms, 
            );
            $totaldatas['cms'] =(int)$countcms;
        }
        if(in_array('messages',$data_exports))
        {
            $countMessage = Db::getInstance()->getValue('SELECT count(*) FROM '._DB_PREFIX_.'customer_thread');
            $contents[]=array(
                'title'=>$this->l('Contact form messages:'), 
                'count'=>$countMessage, 
            );
            $totaldatas['messages'] =(int)$countMessage;
        }
        if($save)
        {
            $this->context->smarty->assign(
                array(
                    'contents'=>$contents
                )
            );
            return $this->display(__FILE__,'views/templates/hook/contents.tpl');
        } 
        else
            return $totaldatas;
    }  
    public function processExport()
    {
        if($this->pres_version==1.4)
             $this->exportDataXML14();
        else   
            $this->exportDataXML();
    }
    public function exportDataXML()
    {
        $zip = new ZipArchive();
        $cacheDir = dirname(__FILE__).'/cache/export/';
        $zip_file_name = 'oc2m_data_'.$this->genSecure(7).'.zip';
        $data_exports=explode(',',$this->data_exports);
        $multishop = in_array('shops',$data_exports);
        $export= new Pres2PresConnectorExport();
        $extra_export= new Pres2PresConnectorExtraExport();
        if ($zip->open($cacheDir.$zip_file_name, ZipArchive::OVERWRITE | ZipArchive::CREATE) === true && $data_exports) {
            if (!$zip->addFromString('DataInfo.xml', $extra_export->exportInfo())) {
               $this->_errors[] = $this->l('Cannot create DataInfo.xml'); 
            }
            if($multishop)
            {
                if(!$export->addFileXMl($zip,'ShopGroup',ShopGroup::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create ShopGroup.xml');
                if(!$export->addFileXMl($zip,'Shop',Shop::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Shop.xml');
                if(!$export->addFileXMl($zip,'ShopUrl',ShopUrl::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create ShopUrl.xml');
            }
            if(!$export->addFileXMl($zip,'Language',Language::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Language.xml');
            if(!$export->addFileXMl($zip,'Currency',Currency::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Currency.xml');
            if(!$export->addFileXMl($zip,'Zone',Zone::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Zone.xml');
            if(!$export->addFileXMl($zip,'Country',Country::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Country.xml');
            if(!$export->addFileXMl($zip,'State',State::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create State.xml');
            if(!$export->addFileXMl($zip,'Employee',Employee::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Employee.xml');
            if(in_array('categories',$data_exports))
            {
                if(!$export->addFileXMl($zip,'Group',Group::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Group.xml');
                if(!$export->addFileXMl($zip,'Category',Category::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Category.xml');
            }
            if(in_array('customers',$data_exports))
            {
                if(!$export->addFileXMl($zip,'Group',Group::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Group.xml');
                if(!$export->addFileXMl($zip,'Customer',Customer::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Customer.xml');
                if (!$export->addFileXMl14($zip,'customergroup','customer_group')) {
                   $this->_errors[] = $this->l('Cannot create customergroup.xml');
                }
                if(!$export->addFileXMl($zip,'Address',Address::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Address.xml');
            }
            if(in_array('manufactures',$data_exports))
            {
                if(!$export->addFileXMl($zip,'Manufacturer',Manufacturer::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Manufacturer.xml');
            }
            if(in_array('suppliers',$data_exports))
            {
                if(!$export->addFileXMl($zip,'Supplier',Supplier::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Supplier.xml');
            }
            if(in_array('carriers',$data_exports))
            {
                if(!$export->addFileXMl($zip,'Carrier',Carrier::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Carrier.xml');
                if (!$export->addFileXMl14($zip,'carrierzone','carrier_zone')) {
                   $this->_errors[] = $this->l('Cannot create carrierzone.xml'); 
                }
                if(!$export->addFileXMl($zip,'RangePrice',RangePrice::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create RangePrice.xml');
                if(!$export->addFileXMl($zip,'RangeWeight',RangeWeight::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create RangeWeight.xml');
                if(!$export->addFileXMl($zip,'Delivery',Delivery::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Delivery.xml');
            }
            if(in_array('cart_rules',$data_exports))
            {
                if(!$export->addFileXMl($zip,'CartRule',CartRule::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create CartRule.xml');
            }
            if(in_array('catelog_rules',$data_exports))
            {
                if(!$export->addFileXMl($zip,'SpecificPriceRule',SpecificPriceRule::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create SpecificPriceRule.xml');            
            }
            if(in_array('products',$data_exports))
            {
                if (!$export->addFileXMl14($zip,'categoryproduct','category_product')) {
                   $this->_errors[] = $this->l('Cannot create categoryproduct.xml');  //extra
                }
                if(!$export->addFileXMl($zip,'Product',Product::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Product.xml');
                if(!$export->addFileXMl($zip,'Tag',Tag::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create tag.xml');
                if(!$export->addFileXMl($zip,'Image',Image::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Image.xml');
                if(!$export->addFileXMl($zip,'Combination',Combination::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Combination.xml');
                if(!$export->addFileXMl($zip,'AttributeGroup',AttributeGroup::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create AttributeGroup.xml');
                if(!$export->addFileXMl($zip,'Attribute',Attribute::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Attribute.xml');
                if (!$export->addFileXMl14($zip,'productattributecombination','product_attribute_combination')) {
                   $this->_errors[] = $this->l('Cannot create productattributecombination.xml'); //extra
                }
                if (!$export->addFileXMl14($zip,'productattributeimage','product_attribute_image')) {
                   $this->_errors[] = $this->l('Cannot create productattributeimage.xml'); //extra
                }
                if (!$export->addFileXMl14($zip,'producttag','product_tag')) {
                   $this->_errors[] = $this->l('Cannot create producttag.xml'); //extra
                }
                if(!$export->addFileXMl($zip,'Feature',Feature::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Feature.xml');
                if(!$export->addFileXMl($zip,'FeatureValue',FeatureValue::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create FeatureValue.xml');   
                if (!$export->addFileXMl14($zip,'featureproduct','feature_product')) {
                   $this->_errors[] = $this->l('Cannot create featureproduct.xml'); // extra feature_product;
                }
                if(!$export->addFileXMl($zip,'SpecificPrice',SpecificPrice::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create SpecificPrice.xml');
                if(!$export->addFileXMl($zip,'Tax',Tax::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Tax.xml');
                if(!$export->addFileXMl($zip,'TaxRulesGroup',TaxRulesGroup::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create TaxRulesGroup.xml');
                if(!$export->addFileXMl($zip,'TaxRule',TaxRule::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create TaxRule.xml');
                if (!$export->addFileXMl14($zip,'productsupplier','product_supplier')) {
                   $this->_errors[] = $this->l('Cannot create productsupplier.xml'); // id_tax, id_rules_group
                }
                if(!$export->addFileXMl($zip,'StockAvailable',StockAvailable::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create StockAvailable.xml');
                if(!$export->addFileXMl14($zip,'CustomizationField','customization_field','id_customization_field',true))
                    $this->_errors[]= $this->l('Cannot create CustomizationField.xml');
                if(in_array('carriers',$data_exports))
                {
                    if (!$export->addFileXMl14($zip,'productcarrier','product_carrier')) {
                       $this->_errors[] = $this->l('Cannot create productcarrier.xml'); 
                    }
                }
                if (!$export->addFileXMl14($zip,'accessory','accessory')) {
                   $this->_errors[] = $this->l('Cannot create accessory.xml'); //extra
                }
            }
            if(in_array('orders',$data_exports))
            {
                if(!$export->addFileXMl($zip,'OrderState',OrderState::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderState.xml');
                if(!$export->addFileXMl($zip,'Cart',Cart::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Cart.xml');
                if(!$export->addFileXMl14($zip,'Customization','customization','id_customization'))
                    $this->_errors[]= $this->l('Cannot create CustomizationField.xml');
                if(!$export->addFileXMl14($zip,'customizeddata','customized_data'))
                    $this->_errors[]= $this->l('Cannot create customizeddata.xml');
                if(!$export->addFileXMl($zip,'Order',Order::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Order.xml');
                if(!$export->addFileXMl($zip,'OrderDetail',OrderDetail::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderDetail.xml');
                if(!$export->addFileXMl($zip,'OrderInvoice',OrderInvoice::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderInvoice.xml');
                if(!$export->addFileXMl($zip,'OrderSlip',OrderSlip::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderSlip.xml');
                if(!$export->addFileXMl($zip,'OrderCarrier',OrderCarrier::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderCarrier.xml');
                if(!$export->addFileXMl($zip,'OrderCartRule',OrderCartRule::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderCartRule.xml');
                if(!$export->addFileXMl($zip,'OrderHistory',OrderHistory::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderHistory.xml');
                if(!$export->addFileXMl($zip,'OrderMessage',OrderMessage::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderMessage.xml');
                if(!$export->addFileXMl($zip,'OrderPayment',OrderPayment::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderPayment.xml');
                if(!$export->addFileXMl($zip,'OrderReturn',OrderReturn::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create OrderReturn.xml');
                if(!$export->addFileXMl($zip,'Message',Message::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Message.xml');
            }
            if(in_array('cms_cateogories',$data_exports))
            {
                if(!$export->addFileXMl($zip,'CMSCategory',CMSCategory::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create CMSCategory.xml');
            }
            if(in_array('cms',$data_exports))
            {
                if(!$export->addFileXMl($zip,'CMS',CMS::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create CMS.xml');
            }
            if(in_array('messages',$data_exports))
            {
                if(!$export->addFileXMl($zip,'Contact',Contact::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create Contact.xml');
                if(!$export->addFileXMl($zip,'CustomerThread',CustomerThread::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create CustomerThread.xml');
                if(!$export->addFileXMl($zip,'CustomerMessage',CustomerMessage::$definition,$multishop))
                    $this->_errors[] = $this->l('Cannot create CustomerMessage.xml');
            }
            
            $zip->close();
            
            if (!is_file($cacheDir.$zip_file_name)) {
                $this->_errors[] = $this->l(sprintf('Could not create %1s', _PS_CACHE_DIR_.$zip_file_name));
            }
            else
            {
                ob_end_clean();
                ob_clean();
                header("Pragma: public"); // required
                header("Expires: 0");
                header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
                header("Cache-Control: private",false); // required for certain browsers 
                header("Content-Transfer-Encoding: binary");
                header("Content-Length: ".filesize($cacheDir.$zip_file_name)); 
                header("Content-type: application/zip"); 
                header("Content-Disposition: attachment; filename=$zip_file_name"); 
                readfile($cacheDir.$zip_file_name);
                unlink($cacheDir.$zip_file_name);
                exit();
            }
        }
        return $this->_errors;
   }
   public function exportDataXML14()
   {
        $zip = new ZipArchive();
        $cacheDir = dirname(__FILE__).'/cache/export/';
        $zip_file_name = 'oc2m_data_'.$this->genSecure(7).'.zip';
        $data_exports=explode(',',$this->data_exports);
        $export= new Pres2PresConnectorExport();
        $extra_export= new Pres2PresConnectorExtraExport();
        if ($zip->open($cacheDir.$zip_file_name, ZipArchive::OVERWRITE | ZipArchive::CREATE) === true && $data_exports) {
            if (!$zip->addFromString('DataInfo.xml', $extra_export->exportInfo())) {
               $this->_errors[] = $this->l('Cannot create DataInfo.xml'); 
            }
            if(!$export->addFileXMl14($zip,'Language','lang','id_lang',false))
                $this->_errors[] = $this->l('Cannot create Language.xml');
            if(!$export->addFileXMl14($zip,'Currency','currency','id_currency',false))
                $this->_errors[] = $this->l('Cannot create Currency.xml');  
            if(!$export->addFileXMl14($zip,'Zone','zone','id_zone',false))
                    $this->_errors[] = $this->l('Cannot create Zone.xml');
            if(!$export->addFileXMl14($zip,'Country','country','id_country',true))
                    $this->_errors[] = $this->l('Cannot create Country.xml');
            if(!$export->addFileXMl14($zip,'State','state','id_state',true))
                    $this->_errors[] = $this->l('Cannot create State.xml');
            if(in_array('employees',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'Employee','employee','id_employee',false))
                    $this->_errors[] = $this->l('Cannot create Employee.xml');
            }
            if(in_array('categories',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'Group','group','id_group',true))
                    $this->_errors[] = $this->l('Cannot create Group.xml');
                if (!$export->addFileXMl14($zip,'categorygroup','category_group')) {
                   $this->_errors[] = $this->l('Cannot create categorygroup.xml');
                }
                if(!$export->addFileXMl14($zip,'Category','category','id_category',true))
                    $this->_errors[] = $this->l('Cannot create Category.xml');
            }
            if(in_array('customers',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'Group','group','id_group',true))
                    $this->_errors[] = $this->l('Cannot create Group.xml');
                if(!$export->addFileXMl14($zip,'Customer','customer','id_customer',false))
                    $this->_errors[] = $this->l('Cannot create Customer.xml');
                if (!$export->addFileXMl14($zip,'customergroup','customer_group')) {
                   $this->_errors[] = $this->l('Cannot create customergroup.xml');
                }
                if(!$export->addFileXMl14($zip,'Address','address','id_address',false))
                    $this->_errors[] = $this->l('Cannot create Address.xml');
            }
            if(in_array('manufactures',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'Manufacturer','manufacturer','id_manufacturer',true))
                    $this->_errors[] = $this->l('Cannot create Manufacturer.xml');
            }
            if(in_array('suppliers',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'Supplier','supplier','id_supplier',true))
                    $this->_errors[] = $this->l('Cannot create Supplier.xml');
            }
            if(in_array('carriers',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'Carrier','carrier','id_carrier',true))
                    $this->_errors[] = $this->l('Cannot create Carrier.xml');
                if (!$export->addFileXMl14($zip,'carrierzone','carrier_zone')) {
                   $this->_errors[] = $this->l('Cannot create carrierzone.xml'); 
                }
                if (!$export->addFileXMl14($zip,'carriergroup','carrier_group')) {
                   $this->_errors[] = $this->l('Cannot create carriergroup.xml'); 
                }
                if(!$export->addFileXMl14($zip,'RangePrice','range_price','id_range_price',false))
                    $this->_errors[] = $this->l('Cannot create RangePrice.xml');
                if(!$export->addFileXMl14($zip,'RangeWeight','range_weight','id_range_weight',false))
                    $this->_errors[] = $this->l('Cannot create RangeWeight.xml');
                if(!$export->addFileXMl14($zip,'Delivery','delivery','id_delivery',false))
                    $this->_errors[] = $this->l('Cannot create Delivery.xml');
            }
            if(in_array('vouchers',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'Discount','discount','id_discount',true))
                    $this->_errors[] = $this->l('Cannot create Discount.xml');
                if(!$export->addFileXMl14($zip,'DiscountType','discount_type','id_discount_type',true))
                    $this->_errors[] = $this->l('Cannot create DiscountType.xml');
            }
            if(in_array('products',$data_exports))
            {
                if (!$export->addFileXMl14($zip,'categoryproduct','category_product')) {
                   $this->_errors[] = $this->l('Cannot create categoryproduct.xml');  //extra
                }
                if(!$export->addFileXMl14($zip,'Product','product','id_product',true))
                    $this->_errors[] = $this->l('Cannot create Product.xml');
                if(!$export->addFileXMl14($zip,'Tag','tag','id_tag'))
                    $this->_errors[] = $this->l('Cannot create Tag.xml');
                if(!$export->addFileXMl14($zip,'Image','image','id_image',true))
                    $this->_errors[] = $this->l('Cannot create Image.xml');
                if(!$export->addFileXMl14($zip,'Combination','product_attribute','id_product_attribute',false))
                    $this->_errors[] = $this->l('Cannot create Combination.xml');
                if(!$export->addFileXMl14($zip,'AttributeGroup','attribute_group','id_attribute_group',true))
                    $this->_errors[] = $this->l('Cannot create AttributeGroup.xml');
                if(!$export->addFileXMl14($zip,'Attribute','attribute','id_attribute',true))
                    $this->_errors[] = $this->l('Cannot create Attribute.xml');
                if (!$export->addFileXMl14($zip,'productattributecombination','product_attribute_combination')) {
                   $this->_errors[] = $this->l('Cannot create productattributecombination.xml'); //extra
                }
                if (!$export->addFileXMl14($zip,'productattributeimage','product_attribute_image')) {
                   $this->_errors[] = $this->l('Cannot create productattributeimage.xml'); //extra
                }
                if (!$export->addFileXMl14($zip,'producttag','product_tag')) {
                   $this->_errors[] = $this->l('Cannot create producttag.xml'); //extra
                }
                if(!$export->addFileXMl14($zip,'Feature','feature','id_feature',true))
                    $this->_errors[] = $this->l('Cannot create Feature.xml');
                if(!$export->addFileXMl14($zip,'FeatureValue','feature_value','id_feature_value',true))
                    $this->_errors[] = $this->l('Cannot create FeatureValue.xml');
                if (!$export->addFileXMl14($zip,'featureproduct','feature_product')) {
                   $this->_errors[] = $this->l('Cannot create featureproduct.xml'); // extra feature_product;
                }
                if(!$export->addFileXMl14($zip,'SpecificPrice','specific_price','id_specific_price',false))
                    $this->_errors[] = $this->l('Cannot create SpecificPrice.xml');
                if(!$export->addFileXMl14($zip,'Tax','tax','id_tax',true))
                    $this->_errors[] = $this->l('Cannot create Tax.xml');
                if(!$export->addFileXMl14($zip,'TaxRulesGroup','tax_rules_group','id_tax_rules_group',false))
                    $this->_errors[] = $this->l('Cannot create TaxRulesGroup.xml');
                if(!$export->addFileXMl14($zip,'TaxRule','tax_rule','id_tax_rule',false))
                    $this->_errors[] = $this->l('Cannot create TaxRule.xml');
                if(!$export->addFileXMl14($zip,'CustomizationField','customization_field','id_customization_field',true))
                    $this->_errors[]= $this->l('Cannot create CustomizationField.xml');
                if (!$export->addFileXMl14($zip,'accessory','accessory')) {
                   $this->_errors[] = $this->l('Cannot create accessory.xml'); //extra
                }
            }
            if(in_array('orders',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'OrderState','order_state','id_order_state',true))
                    $this->_errors[] = $this->l('Cannot create OrderState.xml');
                if(!$export->addFileXMl14($zip,'Cart','cart','id_cart',false))
                    $this->_errors[] = $this->l('Cannot create Cart.xml');
                if(!$export->addFileXMl14($zip,'Customization','customization','id_customization'))
                    $this->_errors[]= $this->l('Cannot create CustomizationField.xml');
                if(!$export->addFileXMl14($zip,'customizeddata','customized_data'))
                    $this->_errors[]= $this->l('Cannot create customizeddata.xml');
                if(!$export->addFileXMl14($zip,'Order','orders','id_order',false))
                    $this->_errors[] = $this->l('Cannot create Order.xml');
                if(!$export->addFileXMl14($zip,'OrderDetail','order_detail','id_order_detail',false))
                    $this->_errors[] = $this->l('Cannot create OrderDetail.xml');
                if(!$export->addFileXMl14($zip,'OrderSlip','order_slip','id_order_slip',false))
                    $this->_errors[] = $this->l('Cannot create OrderSlip.xml');
                if(!$export->addFileXMl14($zip,'OrderHistory','order_history','id_order_history',false))
                    $this->_errors[] = $this->l('Cannot create OrderHistory.xml');
                if(!$export->addFileXMl14($zip,'OrderMessage','order_message','id_order_message',true))
                    $this->_errors[] = $this->l('Cannot create OrderMessage.xml');
                if(!$export->addFileXMl14($zip,'OrderReturn','order_return','id_order_return',false))
                    $this->_errors[] = $this->l('Cannot create OrderReturn.xml');
                if(!$export->addFileXMl14($zip,'OrderReturn','order_return','id_order_return',false))
                    $this->_errors[] = $this->l('Cannot create OrderReturn.xml');
                if(!$export->addFileXMl14($zip,'Message','message','id_message',false))
                    $this->_errors[] = $this->l('Cannot create Message.xml');
            }
            if(in_array('cms_cateogories',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'CMSCategory','cms_category','id_cms_category',true))
                    $this->_errors[] = $this->l('Cannot create CMSCategory.xml');
            }
            if(in_array('cms',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'CMS','cms','id_cms',true))
                    $this->_errors[] = $this->l('Cannot create CMS.xml');
            }
            if(in_array('messages',$data_exports))
            {
                if(!$export->addFileXMl14($zip,'Contact','contact','id_contact',true))
                    $this->_errors[] = $this->l('Cannot create Contact.xml');
                if(!$export->addFileXMl14($zip,'CustomerThread','customer_thread','id_customer_thread',false))
                    $this->_errors[] = $this->l('Cannot create CustomerThread.xml');
                if(!$export->addFileXMl14($zip,'CustomerMessage','customer_message','id_customer_message',false))
                    $this->_errors[] = $this->l('Cannot create CustomerMessage.xml');
            }
            $zip->close();
            if (!is_file($cacheDir.$zip_file_name)) {
                $this->_errors[] = $this->l(sprintf('Could not create %1s', _PS_CACHE_DIR_.$zip_file_name));
            }
            else
            {
                ob_end_clean();
                ob_clean();
                header("Pragma: public"); // required
                header("Expires: 0");
                header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
                header("Cache-Control: private",false); // required for certain browsers 
                header("Content-Transfer-Encoding: binary");
                header("Content-Length: ".filesize($cacheDir.$zip_file_name)); 
                header("Content-type: application/zip"); 
                header("Content-Disposition: attachment; filename=$zip_file_name"); 
                readfile($cacheDir.$zip_file_name);
                unlink($cacheDir.$zip_file_name);
                exit();
            }
        }
        return $this->_errors;
   }
   public function genSecure($size)
   {
        $chars = md5(time()); 
        $code = '';
        for ($i = 1; $i <= $size; ++$i)
        {
            $char= Tools::substr($chars, rand(0, Tools::strlen($chars) - 1), 1);
            if($char=='e')
                $char='a';
            $code .= $char;
        }
            
        return $code;
   }
   public static function upperFirstChar($t)
   {
        return Tools::ucfirst($t);
   }
}